﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System.Drawing;

namespace DrawFilterDrawRightBorders
{
    class CustomDrawFilter : IUIElementDrawFilter
    {

        public Infragistics.Win.DrawPhase GetPhasesToFilter(
      ref Infragistics.Win.UIElementDrawParams drawParams)
        {

            if (drawParams.Element is CellUIElement || drawParams.Element is RowCellAreaUIElement )
                return DrawPhase.BeforeDrawBorders;
            else if (drawParams.Element is EditorWithTextUIElement || drawParams.Element is DateTimeEditorUIElement)// if you have a DateTimeEditorUIElement
                return DrawPhase.BeforeDrawBackColor;
            else

                return DrawPhase.None;
        }

        public bool DrawElement(Infragistics.Win.DrawPhase drawPhase,
          ref Infragistics.Win.UIElementDrawParams drawParams)
        {

            if (drawParams.Element is CellUIElement)
            {
                var borderPen = new Pen(Color.Black);
                var elementRect = drawParams.Element.Rect;
                var cell = drawParams.Element as CellUIElement;


                //draw the right borders
                    drawParams.Graphics.DrawLine(borderPen,
                    new Point(elementRect.Right, elementRect.Bottom),
                    new Point(elementRect.Right, elementRect.Top));
                
                //if the column is "Title" and the row index is 
                // 3 or 1 draw the bottom border
                //This way you can access individual cells
                if (cell.Column.Index == 1 && (cell.Row.Index == 4 || cell.Row.Index == 2))
                {
                    drawParams.Graphics.DrawLine(borderPen,
                    elementRect.Location,
                    new Point(elementRect.Right, elementRect.Top));
                }

            }
            //prevents the borders from drawing as they normally would
            //if you set it to false the grid will draw it's borders properly
            //but your custom borders will still aply
            return true;
        }
    }
}
